// This is a generated file, modify: generate/templates/class_header.h

#ifndef GITSIGNATURE_H
#define GITSIGNATURE_H
#include <nan.h>
#include <string>
#include <queue>
#include <utility>

#include "async_baton.h"
#include "promise_completion.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"

#include "../include/time.h"
#include "../include/repository.h"

using namespace node;
using namespace v8;

class GitSignature : public Nan::ObjectWrap {
public:

  static Nan::Persistent<Function> constructor_template;
  static void InitializeComponent (Local<v8::Object> target);
  // diagnostic count of self-freeing object instances
  static int SelfFreeingInstanceCount;
  // diagnostic count of constructed non-self-freeing object instances
  static int NonSelfFreeingConstructedCount;

  git_signature *GetValue();
  void ClearValue();

  static Local<v8::Value> New(const git_signature *raw, bool selfFreeing, bool shouldDuplicate = false);
  bool selfFreeing;



private:


  GitSignature(git_signature *raw, bool selfFreeing, bool shouldDuplicate = false);
  ~GitSignature();

  static NAN_METHOD(JSNewFunction);
  static NAN_METHOD(GetSelfFreeingInstanceCount);
  static NAN_METHOD(GetNonSelfFreeingConstructedCount);

  static NAN_METHOD(Name);
  static NAN_METHOD(Email);
  static NAN_METHOD(When);

  static NAN_METHOD(Default);

  struct DupBaton {
    int error_code;
    const git_error* error;
    git_signature * dest;
    const git_signature * sig;
  };
  class DupWorker : public Nan::AsyncWorker {
  public:
    DupWorker(
      DupBaton *_baton,
      Nan::Callback *callback
    ) : Nan::AsyncWorker(callback)
      , baton(_baton) {};
    ~DupWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    DupBaton *baton;
  };

  static NAN_METHOD(Dup);

  static NAN_METHOD(Free);

  static NAN_METHOD(Create);

  static NAN_METHOD(Now);
  git_signature *raw;
};

#endif
